Uses Crt, Dos, UScreen;
Type
  PicHeader = Record
    ID : Array[1..2] Of Char; {'PV'}
    NPlan : Word;
  End;
  BmpHeader = Record
    ID : Array[1..2] Of Char; {'BM'}
    Length : LongInt; {Taille du fichier}
    Reserved1 : Word;
    Reserved2 : Word;
    BitOffset : LongInt; {54 + palette ?}

    Size : LongInt; {40}
    X, Y : LongInt;
    NPlanes : Word;
    BitCount : Word;
    Compression : LongInt; {0}
    SizeImage : LongInt;
    XPM, YPM : LongInt;
    ClrUsed : LongInt; {0}
    ClrImportant : LongInt; {0}
  End;

  HeaderData = Record
    ID : Array[1..8] Of Char;
    UnKnow1 : Word;
    Folder : Array[1..8] Of Char;
    Comment : Array[1..40] Of Char;
    UnKnow2 : Word;
    UnKnow3 : LongInt;
    Name : Array[1..8] Of Char;
    UnKnow4 : LongInt;
    FileSize : LongInt;
    UnKnow5 : LongInt;
    DataSize : Array[1..4] of Byte;
  End;

  MaxData = Array[1..320, 1..200] Of Byte;

Var
  F, G : File;
  BmpHead : BmpHeader;
  PicHead : PicHeader;
  Head : HeaderData;
  Plan : ^MaxData;

  OldInt08h : Procedure;

  CurrentG : Byte; {Pour la couleur qui change}
  IncMode : Integer;

  X, Y, I, J : Word;
  Data : Byte;
  DataR, DataG, DataB : Byte;

  Palette : Array[1..768] Of Byte;

  NPlan, Deca : Byte;
  CheckSum : Word;

(*************** Detournement de l'interruption 8 (timer) *****************)
{Pour faire une palette qui change de couleur (choix du niveau de gris)}
{$F+}
Procedure NewInt08h; Interrupt;
Begin
  Inc(CurrentG, IncMode);
  If CurrentG = 16 Then IncMode := -1;
  If CurrentG = 0 Then IncMode := 1;
  Port[$3c8] := 2;
  Port[$3c9] := 0;
  Port[$3c9] := 32 + CurrentG;
  Port[$3c9] := 0;

  Asm PushF End; {Simule un appel d'interruption}
  OldInt08h; {Rappelle l'ancienne interruption}
End;
{$F-}

(************************ Gestion d'erreurs ********************************)
{Oups une erreur, si je la connais je le dis gentiment}
Procedure Error(ErrorStr : String);
Begin
  Set80x25;
  Cls(0, 7, 0);
  WriteLn('Picture Maker V1.0 by Philippe Gervaise aKa CandyMan');
  Write(ErrorStr);
  SetIntVec(8, @OldInt08h); {On rtablit l'int 08h pour pas
                             que ca fasse bizarre aprs}
  Halt;
End;

Procedure Pal(ColorNo : Byte; R,G,B : Byte);
Begin
 Port[$3c8] := ColorNo;
 Port[$3c9] := R;
 Port[$3c9] := G;
 Port[$3c9] := B;
End;

Var Line : String;
Begin
  If ParamCount = 0 Then
  Begin
    {Affichage de l'aide}
    WriteLn;
    WriteLn('PV <file>');
    Write('   <file> : Name of the file where picture is');
    Halt;
  End;

  {Je met ce mode car je l'aime mieux que le 80x25}
  Set80x28;
  {Dtourne l'interruption 8 (timer) pour de zolis effets graphiques}
  GetIntVec(8, @OldInt08h);
  SetIntVec(8, @NewInt08h);
  Cls(176, 1, 7); {Remplit  la "Turbo Pascal"}
  HLine(0, 79, 0, 219, 7, 0); {De mme}
  PutStr(15, 0, 'Picture Maker V1.0 by Philippe Gervaise aKa CandyMan', 0, 7);

  {Choisie une belle font}
  Car := Car2;

  Assign(F, ParamStr(1));
  {$I-}
  Reset(F, 1);
  If IoResult <> 0 Then Error('File ' + ParamStr(1) + ' not found !');
  {$I+}


  Line := Ask('Output filename (without extension): ', Alpha + Digit + NoSpace);
  Line := Line + '.89e';

  Assign(G, Line);
  {$I-}
  ReWrite(G, 1);
  If IoResult <> 0 Then Error('Output filename invalid !');
  {$I+}

  Line := Ask('Name that appeared in the calculator : ', All);
  If Length(Line) < 1 Then Error('Calculator filename invalid !');
  For I := 1 To 8 Do
  Begin
    Head.Name[I] := Line[I];
    If I + 1 > Length(Line) Then Break;
  End;
  If I < 8 Then Head.Name[I + 1] := Chr(0);


  Head.ID := '**TI89**';
  Head.UnKnow1 := 1;
  Head.Folder := 'main' + Chr(0) + '   ';
  For I := 1 To 40 Do
    Head.Comment[I] := Chr(0);
  Head.UnKnow2 := 1;
  Head.UnKnow3 := 82;
  Head.UnKnow4 := 12;
  Head.FileSize := 0; {Pour apres}
  Head.UnKnow5 := 23205;
  Head.DataSize[1] := 0;
  Head.DataSize[2] := 0;
  Head.DataSize[3] := 0;
  Head.DataSize[4] := 0;

  BlockWrite(G, Head, SizeOf(HeaderData));

  BlockRead(F, BmpHead, SizeOf(BmpHeader));

  GetMem(Plan, 64000);
  FillChar(Plan^, 64000, 0);


  ChoiceTitle := 'Choose number of gray level';
  AddChoice('2 gray level');
  AddChoice('4 gray level');
  Addchoice('8 gray level');

  NPlan := Choice;
  DoneChoice;

  Deca := 128;
  If NPlan > 1 Then Inc(Deca, 64);
  If NPlan > 2 Then Inc(Deca, 32);
  Seek(F, 54);
  Asm
    Mov AX, 13h
    Int 10h
  End;

  {Remet l'interruption 8 comme elle etait}
  SetIntVec(8, @OldInt08h);

  {Met une palette en N&B, 0 est deja le noir}
  For I := 2 To 8 Do
    Pal(I - 1, 8 * I - 1, 8 * I - 1, 8 * I - 1);

  For Y := 1 To BmpHead.Y Do
  Begin
    For X := 1 To BmpHead.X Do
    Begin
      {C'est lent de lire trois fois mais ca marche ...}
      BlockRead(F, DataR, 1);
      BlockRead(F, DataG, 1);
      BlockRead(F, DataB, 1);
      {Convertit en Noir et Blanc, superbe formule !}
      Data := Round(DataR * 0.299 + DataG * 0.587 + DataB * 0.114);

      Plan^[X, BmpHead.Y - Y + 1] := (Data And Deca) Shr 5;
      {Affiche le pixel trait}
      Mem[$A000 : X + (BmpHead.Y - Y + 1) * 320] :=
        (Data And Deca) Shr 5;
    End;
    {Gere l'adresse pair, faut pas chercher  comprendre ...
     C'est  cause de Windows, voir sa doc (win32.hlp)}
    If BmpHead.SizeImage > BmpHead.X * BmpHead.Y * 3 Then
      For I := 1 To (BmpHead.SizeImage Div BmpHead.Y) - 3 * BmpHead.X Do
        BlockRead(F, DataR, 1);
  End;

  Close(F);

  {Ecrit les donnees dans le string}

  PicHead.ID := 'PV';
  PicHead.NPlan := 256 * NPlan;
  BlockWrite(G, PicHead, SizeOf(PicHeader));

  For I := 1 To NPlan Do
  Begin
    {Ecrit la taille Y du plan en Octets}
    Data := 0;
    BlockWrite(G, Data, 1);
    Data := BmpHead.Y;
    BlockWrite(G, Data, 1);

    {Ecrit la taille X du plan en octet}
    Data := 0;
    BlockWrite(G, Data, 1);
    Data := BmpHead.X Div 8 + 1;
    If BmpHead.X Mod 8 = 0 Then Dec(Data);
    BlockWrite(G, Data, 1);


    {Ecrit les donnes du plan}
    For Y := 1 To BmpHead.Y Do
    Begin
      X := 1;
      Repeat
        Data := 0;
        For J := 1 To 8 Do
        Begin
          If X <= BmpHead.X Then
            If Plan^[X, Y] And (1 Shl (3 - I)) = 0 Then
              Inc(Data);

          If J <> 8 Then Data := Data Shl 1;
          Inc(X);
        End;
        BlockWrite(G, Data, 1);
      Until X > BmpHead.X;
    End;
  End;

  Data := 0; {Euh ... fin de string, je sais c'est stupide !, m'en fous}
  BlockWrite(G, Data, 1);
  Data := 0; {Type Expression, facile non ?}
  BlockWrite(G, Data, 1);

  {Mise  jour de l'entte du fichier de sortie}
  Seek(G, 0);
  Head.FileSize := FileSize(G); {Ligne inutile, sert  faire beau}
  Head.DataSize[3] := (FileSize(G) - SizeOf(HeaderData)) Shr 8;
  Head.DataSize[4] := (FileSize(G) - SizeOf(HeaderData)) And 255;
  BlockWrite(G, Head, SizeOf(HeaderData));

  {Calcule le checksum, pour Ti-Graph Link}
  CheckSum := 0;
  Seek(G, 86);
  For I := 86 To FileSize(G) - 1 Do
  Begin
    BlockRead(G, Data, 1);
    Inc(CheckSum, Data);
  End;

  Seek(G, FileSize(G));
  Data := CheckSum And 255;
  BlockWrite(G, Data, 1);
  Data := CheckSum Shr 8;
  BlockWrite(G, Data, 1);

  {Mise  jour de l'entte du fichier de sortie (Eh oui encore !)}
  Head.FileSize := FileSize(G);
  Seek(G, 0);
  BlockWrite(G, Head, SizeOf(HeaderData));

  Close(G);

  {On attends la frappe d'une touche pour que l'utilisateur puisse
   admirer l'image}
  Repeat Until KeyPressed;

  {On se remet quand mme en mode texte}
  TextMode(3);
  {Pour enfin afficher THE chaine}
  WriteLn('Picture Maker V1.0 by Philippe Gervaise aKa CandyMan');

  FreeMem(Plan, 64000);
End.

{Ouf c'est la fin}